﻿using EnotaryoPH.Data.Entities;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace EnotaryoPH.Web.Common.Models
{
    public class IdentificationDocumentModel
    {
        public IdentificationDocumentModel()
        { }

        public IdentificationDocumentModel(IdentificationDocument document)
        {
            using var stream = new MemoryStream(document.File);
            File = new FormFile(stream, 0, stream.Length, document.Filename, document.Filename);
            ExpirationDate = document.ExpirationDate;
            DateIssued = document.DateIssued;
            PlaceIssued = document.PlaceIssued;
            IdNumber = document.IdNumber;
            Filename = document.Filename;
            ImageBase64Url = File.ToBase64StringUrl();
            IdentificationType = document.Type;
        }

        public DateTime? DateIssued { get; set; }
        public DateTime? ExpirationDate { get; set; }
        public IFormFile File { get; set; }
        public string Filename { get; set; }
        public string IdentificationType { get; set; }
        public List<SelectListItem>? IdentificationTypes { get; set; }
        public string IdNumber { get; set; }
        public string? ImageBase64Url { get; set; }
        public string PlaceIssued { get; set; }
    }
}